package com.jiuqi.mde;

import com.jiuqi.util.RecIndex;

public final class MDEIndex extends RecIndex {
   public void genOrder(MDEDimValueSet dimValues) throws MDEException {
      this.genOrder(dimValues, false);
   }

   public void genOrder(MDEDimValueSet dimValues, boolean clearOrder) throws MDEException {
      int order = dimValues.dimensions().indexOf("顺序号");
      if (order >= 0) {
         if (order != dimValues.dimensions().size() - 1) {
            throw new MDEException("顺序号维度必须是维度集合的最后一个");
         } else {
            int index;
            if (dimValues.getValue(order) != null) {
               index = -1;
               if (clearOrder) {
                  index = this.search(dimValues);
               }

               if (index < 0) {
                  return;
               }
            }

            dimValues.setValue(order, MDEDimension.MAX_INT_DIM_VALUE);
            index = this.search(dimValues);
            if (index >= 0) {
               throw new MDEException("顺序号维度已达到最大值");
            } else {
               index = -1 - index;
               if (index > 0 && dimValues.compareNoOrder(this.getKey(index - 1)) == 0) {
                  MDEDimValueSet values = (MDEDimValueSet)this.getKey(index - 1);
                  dimValues.setValue(order, new Integer((Integer)values.getValue(order) + 1));
               } else {
                  dimValues.setValue(order, new Integer(1));
               }

            }
         }
      }
   }

   public int findNoOrder(MDEDimValueSet dimValues) {
      int index = this.searchfirst(dimValues);
      if (index < 0) {
         index = -1 - index;
         if (index < this.size() && dimValues.compareNoOrder(this.getValue(index)) == 0) {
            return index;
         }

         if (index > 0 && dimValues.compareNoOrder(this.getValue(index - 1)) == 0) {
            return index - 1;
         }
      }

      return -1;
   }

   public int findFirstNoOrder(MDEDimValueSet dimValues) {
      MDEDimValueSet newValues = dimValues;
      int order = dimValues.dimensions().indexOf("顺序号");
      if (order >= 0) {
         newValues = (MDEDimValueSet)dimValues.clone();
         newValues.setValue(order, (Object)null);
      }

      return this.findNoOrder(newValues);
   }
}
